/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.dfareporting.model;

import com.google.api.client.json.GenericJson;

/**
 * Represents an activity group.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the DFA Reporting API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Activities extends GenericJson {

  /**
   * List of activity filters. The dimension values need to be all either of type "dfa:activity" or
   * "dfa:activityGroup".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<DimensionValue> filters;

  static {
    // hack to force ProGuard to consider DimensionValue used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(DimensionValue.class);
  }

  /**
   * The kind of resource this is, in this case dfareporting#activities.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * List of names of floodlight activity metrics.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<String> metricNames;

  /**
   * List of activity filters. The dimension values need to be all either of type "dfa:activity" or
   * "dfa:activityGroup".
   * The value returned may be {@code null}.
   */
  public java.util.List<DimensionValue> getFilters() {
    return filters;
  }

  /**
   * List of activity filters. The dimension values need to be all either of type "dfa:activity" or
   * "dfa:activityGroup".
   * The value set may be {@code null}.
   */
  public Activities setFilters(java.util.List<DimensionValue> filters) {
    this.filters = filters;
    return this;
  }

  /**
   * The kind of resource this is, in this case dfareporting#activities.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * The kind of resource this is, in this case dfareporting#activities.
   * The value set may be {@code null}.
   */
  public Activities setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * List of names of floodlight activity metrics.
   * The value returned may be {@code null}.
   */
  public java.util.List<String> getMetricNames() {
    return metricNames;
  }

  /**
   * List of names of floodlight activity metrics.
   * The value set may be {@code null}.
   */
  public Activities setMetricNames(java.util.List<String> metricNames) {
    this.metricNames = metricNames;
    return this;
  }

}
