/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.dfareporting.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.util.DateTime;

/**
 * Represents a DimensionValuesRequest.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the DFA Reporting API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class DimensionValueRequest extends GenericJson {

  /**
   * The name of the dimension for which values should be requested.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String dimensionName;

  /**
   * The end date of the date range for which to retrieve dimension values. A string of the format:
   * "yyyy-MM-dd".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private DateTime endDate;

  /**
   * The list of filters by which to filter values. The filters are ANDed.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<DimensionFilter> filters;

  static {
    // hack to force ProGuard to consider DimensionFilter used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(DimensionFilter.class);
  }

  /**
   * The kind of request this is, in this case dfareporting#dimensionValueRequest.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * The start date of the date range for which to retrieve dimension values. A string of the
   * format: "yyyy-MM-dd".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private DateTime startDate;

  /**
   * The name of the dimension for which values should be requested.
   * The value returned may be {@code null}.
   */
  public String getDimensionName() {
    return dimensionName;
  }

  /**
   * The name of the dimension for which values should be requested.
   * The value set may be {@code null}.
   */
  public DimensionValueRequest setDimensionName(String dimensionName) {
    this.dimensionName = dimensionName;
    return this;
  }

  /**
   * The end date of the date range for which to retrieve dimension values. A string of the format:
   * "yyyy-MM-dd".
   * The value returned may be {@code null}.
   */
  public DateTime getEndDate() {
    return endDate;
  }

  /**
   * The end date of the date range for which to retrieve dimension values. A string of the format:
   * "yyyy-MM-dd".
   * The value set may be {@code null}.
   */
  public DimensionValueRequest setEndDate(DateTime endDate) {
    this.endDate = endDate;
    return this;
  }

  /**
   * The list of filters by which to filter values. The filters are ANDed.
   * The value returned may be {@code null}.
   */
  public java.util.List<DimensionFilter> getFilters() {
    return filters;
  }

  /**
   * The list of filters by which to filter values. The filters are ANDed.
   * The value set may be {@code null}.
   */
  public DimensionValueRequest setFilters(java.util.List<DimensionFilter> filters) {
    this.filters = filters;
    return this;
  }

  /**
   * The kind of request this is, in this case dfareporting#dimensionValueRequest.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * The kind of request this is, in this case dfareporting#dimensionValueRequest.
   * The value set may be {@code null}.
   */
  public DimensionValueRequest setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The start date of the date range for which to retrieve dimension values. A string of the
   * format: "yyyy-MM-dd".
   * The value returned may be {@code null}.
   */
  public DateTime getStartDate() {
    return startDate;
  }

  /**
   * The start date of the date range for which to retrieve dimension values. A string of the
   * format: "yyyy-MM-dd".
   * The value set may be {@code null}.
   */
  public DimensionValueRequest setStartDate(DateTime startDate) {
    this.startDate = startDate;
    return this;
  }

}
